<?php

declare(strict_types=1);

namespace Dedi\SyliusTaxonTypePlugin\Model;

use Doctrine\ORM\Mapping as ORM;
use Sylius\Component\Core\Model\TaxonInterface;

trait BrandAwareTrait
{
    #[ORM\ManyToOne(targetEntity: "\Dedi\SyliusTaxonTypePlugin\Model\TypedTaxonInterface", cascade: ['persist'], inversedBy: 'brandProducts')]
    #[ORM\ORM\JoinColumn(name: 'brand_id', referencedColumnName: 'id', onDelete: 'SET NULL')]
    protected ?TaxonInterface $brand = null;

    public function getBrand(): ?TaxonInterface
    {
        return $this->brand;
    }

    public function setBrand(?TaxonInterface $brand): self
    {
        $this->brand = $brand;

        return $this;
    }
}
